=== debian/changelog ===
di (4.48-1) unstable; urgency=medium

  * New upstream release
  * Use dh_auto_build: allows cross build (Closes: #930819)
  * Fix FTBFS due to renamed README

 -- Michael Ablassmeier <abi@debian.org>  Wed, 06 Jan 2021 12:35:55 +0100
