=== debian/changelog ===
di (4.51-1) unstable; urgency=medium

  * New upstream release.
  * Update upstream homepage.

 -- Michael Ablassmeier <abi@debian.org>  Sat, 17 Sep 2022 18:36:48 +0200
