=== C/Makefile ===
--- 
+++ 
@@ -2,6 +2,7 @@
 #  di makefile - C
 #
 #  Copyright 2001-2018 Brad Lanam Walnut Creek CA, USA
+#  Copyright 2023 Brad Lanam, Pleasant Hill, CA
 #
 
 MKC_PREFIX = di
@@ -43,7 +44,11 @@
 # installation options
 #
 prefix = /usr/local
-LOCALEDIR = $(prefix)/share/locale
+PREFIX = $(prefix)
+BINDIR = $(PREFIX)/bin
+DATADIR = $(PREFIX)/share
+MANDIR = $(DATADIR)/man
+LOCALEDIR = $(DATADIR)/locale
 
 ###
 # additional flags/libraries
@@ -179,87 +184,6 @@
 		CC=gcc LD=gcc EXE_EXT=".exe" OBJ_EXT=".o" \
 		DI_CFLAGS="$(DI_CFLAGS) -g -O2" \
 		LDFLAGS="-g -O2 -Zexe" di.exe
-
-.PHONY: bsd43-cc
-bsd43-cc:
-	@$(MAKE) ../dioptions.dat
-	@echo ':' > $(MKC_ENV);chmod a+rx $(MKC_ENV)
-	@-$(RM) -f config.h mkconfig.cache mkc*.vars tests.done
-	sleep 1
-	$(CP) configs/config.bsd43.cc config.h
-	sleep 1
-	@touch $(MKC_REQLIB)
-	$(MAKE) _MKCONFIG_SHELL=$(MKCONFIG_SHELL) \
-		CC=cc LD=cc EXE_EXT="" OBJ_EXT=".o" \
-		DI_CFLAGS="$(DI_CFLAGS) -O" \
-		LDFLAGS="-O" di-programs
-
-.PHONY: bsd43-gcc
-bsd43-gcc:
-	@$(MAKE) ../dioptions.dat
-	@echo ':' > $(MKC_ENV);chmod a+rx $(MKC_ENV)
-	@-$(RM) -f config.h mkconfig.cache mkc*.vars tests.done
-	sleep 1
-	$(CP) configs/config.bsd43.gcc config.h
-	sleep 1
-	@touch $(MKC_REQLIB)
-	$(MAKE) _MKCONFIG_SHELL=$(MKCONFIG_SHELL) \
-		CC=gcc LD=gcc EXE_EXT="" OBJ_EXT=".o" \
-		DI_CFLAGS="$(DI_CFLAGS) -O2" \
-		LDFLAGS="-O2" di-programs
-
-.PHONY: ultrix-cc
-ultrix-cc:
-	@$(MAKE) ../dioptions.dat
-	@echo ':' > $(MKC_ENV);chmod a+rx $(MKC_ENV)
-	@-$(RM) -f config.h mkconfig.cache mkc*.vars tests.done
-	sleep 1
-	$(CP) configs/config.ultrix.cc config.h
-	sleep 1
-	@touch $(MKC_REQLIB)
-	$(MAKE) _MKCONFIG_SHELL=$(MKCONFIG_SHELL) \
-		CC=cc LD=cc EXE_EXT="" OBJ_EXT=".o" \
-		DI_CFLAGS="$(DI_CFLAGS) -O" \
-		LDFLAGS="-O" di-programs
-
-.PHONY: ultrix-gcc
-ultrix-gcc:
-	@$(MAKE) ../dioptions.dat
-	@echo ':' > $(MKC_ENV);chmod a+rx $(MKC_ENV)
-	@-$(RM) -f config.h mkconfig.cache mkc*.vars tests.done
-	sleep 1
-	$(CP) configs/config.ultrix.gcc config.h
-	sleep 1
-	@echo '-lintl' > $(MKC_REQLIB)
-	$(MAKE) _MKCONFIG_SHELL=$(MKCONFIG_SHELL) \
-		CC=gcc LD=gcc EXE_EXT="" OBJ_EXT=".o" \
-		DI_CFLAGS="$(DI_CFLAGS) -O2" \
-		LDFLAGS="-O2" di-programs
-
-.PHONY: hpux-cc
-hpux-cc:
-	@$(MAKE) -e ../dioptions.dat
-	@$(MAKE) CC=/usr/ccs/bin/cc -e $(MKC_ENV)
-	@-$(RM) -f config.h mkconfig.cache mkc*.vars tests.done
-	sleep 1
-	$(CP) configs/config.hpux.bcc config.h
-	sleep 1;touch $(MKC_REQLIB)
-	. ./$(MKC_ENV);$(MAKE) -e CC=/usr/ccs/bin/cc \
-		_MKCONFIG_SHELL=$(MKCONFIG_SHELL) di-programs
-
-.PHONY: xenix-cc
-xenix-cc:
-	@$(MAKE) ../dioptions.dat
-	@echo ':' > $(MKC_ENV);chmod a+rx $(MKC_ENV)
-	@-$(RM) -f config.h mkconfig.cache mkc*.vars tests.done
-	sleep 1
-	$(CP) configs/conf.xenix.cc config.h
-	sleep 1
-	@touch $(MKC_REQLIB)
-	$(MAKE) _MKCONFIG_SHELL=$(MKCONFIG_SHELL) \
-		CC=cc LD=cc EXE_EXT="" OBJ_EXT=".o" \
-		DI_CFLAGS="$(DI_CFLAGS) -O" \
-		LDFLAGS="-O" di-programs
 
 ###
 # cleaning
@@ -318,7 +242,7 @@
 .PHONY: install
 install:
 	$(MAKE) all
-	. ./$(MKC_ENV);cd ..;$(MAKE) -e prefix=$(prefix) \
+	. ./$(MKC_ENV);cd ..;$(MAKE) -e PREFIX=$(PREFIX) \
 		LOCALEDIR=$(LOCALEDIR) FROMDIR=C install
 
 ###
@@ -483,3 +407,54 @@
 	$(MKDIR) -p ./rpmbuild/SOURCES
 	$(MKDIR) -p ./rpmbuild/BUILD
 	$(CP) -f $(DI_DIR)/di-$(DI_VERSION).tar.gz ./rpmbuild/SOURCES
+	$(LN) -f ./rpmbuild/SOURCES/di-$(DI_VERSION).tar.gz ./rpmbuild/SOURCES/download
+	$(RPMBUILD) --define="_topdir `pwd`/rpmbuild" -ba ../di.spec
+	$(TEST) -f ./rpmbuild/RPMS/$(MARCH)/di-$(DI_VERSION)-1.$(MARCH).rpm || exit 1
+	$(TEST) -f ./rpmbuild/SRPMS/di-$(DI_VERSION)-1.src.rpm || exit 1
+	$(TEST) -d ./rpmbuild && rm -rf ./rpmbuild
+
+# needs environment
+.PHONY: rtest-env
+rtest-env:
+	@echo "$(_MKCONFIG_SYSTYPE)"
+	@echo "$(_MKCONFIG_SYSREV)"
+	@echo "$(_MKCONFIG_SYSARCH)"
+	@echo "$(CC)"
+	@echo "$(_MKCONFIG_USING_GCC)"
+	@echo "$(CFLAGS_OPTIMIZE)"
+	@echo "$(CFLAGS_COMPILER)"
+	@echo "$(LDFLAGS_COMPILER)"
+	@echo "$(OBJ_EXT)"
+	@echo "$(EXE_EXT)"
+	@echo "$(XMSGFMT)"
+
+.PHONY: test-env
+test-env:
+	@echo "cc: $(CC)"
+	@echo "make: $(MAKE)"
+
+gconfig.h:	$(MKC_ENV) mkc_config/di-getoptn.mkc
+	@-$(RM) -f gconfig.h
+	@if [ "$(MKCONFIG_TYPE)" = "sh" -o "$(MKCONFIG_TYPE)" = "" ]; then \
+		. ./$(MKC_ENV); \
+		$(_MKCONFIG_SHELL) $(MKC_DIR)/mkconfig.sh \
+		$(MKC_CONF_GETOPTN); fi
+	@if [ "$(MKCONFIG_TYPE)" = "perl" ]; then \
+		. ./$(MKC_ENV); \
+		perl $(MKC_DIR)/mkconfig.pl \
+		$(MKC_CONF_GETOPTN); fi
+
+getoptn_test$(OBJ_EXT):	getoptn.c gconfig.h getoptn.h
+	@. ./$(MKC_ENV);$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -compile \
+		-DTEST_GETOPTN=1 \
+		-o getoptn_test$(OBJ_EXT) getoptn.c
+
+getoptn.reqlibs:	$(MKC_ENV) gconfig.h
+	@. ./$(MKC_ENV);$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -reqlib \
+		-o getoptn.reqlibs gconfig.h
+
+getoptn_test.exe:	getoptn_test$(OBJ_EXT) getoptn.reqlibs
+	@. ./$(MKC_ENV);$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -link -exec \
+		$(MKC_ECHO) -r getoptn.reqlibs \
+		-o getoptn_test.exe $(LDFLAGS) \
+		getoptn_test$(OBJ_EXT)
