=== debian/changelog ===
di (4.52-2) unstable; urgency=medium

  * Import package to salsa
   + debian/control: add VCS fields, Rules-Requires-Root,
   wrap-and-sort
   + debian/compat: remove, add dependency in debian/control

 -- Michael Ablassmeier <abi@debian.org>  Wed, 02 Aug 2023 22:15:13 +0200

di (4.52-1) unstable; urgency=medium

  * New upstream release.
  * Add debian/watch

 -- Michael Ablassmeier <abi@debian.org>  Thu, 20 Jul 2023 09:08:24 +0200
