=== debian/changelog ===
di (4.53-1) unstable; urgency=medium

  * New upstream version (Closes: #1074908)
  * debian/copyright: update format
  * Remove obsolete debian/patches

 -- Michael Ablassmeier <abi@debian.org>  Wed, 03 Jul 2024 15:19:36 +0200
